SystemOrganization addCategory: #'AncientCompiler-Frontend'!

CompilerContext subclass: #ACCompilerContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AncientCompiler-Frontend'!

ACCompilerContext class
	instanceVariableNames: 'ui'!

ACCompilerContext class
	instanceVariableNames: 'ui'!

!ACCompilerContext class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/14/2013 19:30'!
initialize
	super initialize.
	ui := ACCompilerContext basicNew initialize.! !

!ACCompilerContext class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 12:53'!
new
	^self error: 'Cannot create a Ancient compiler context'! !

!ACCompilerContext class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/14/2013 19:30'!
uniqueInstance
	^ui! !

!ACCompilerContext methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 12:18'!
compilerName
	^#AncientCompiler! !

!ACCompilerContext methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/30/2011 00:18'!
defaultStyler
	^(Smalltalk at: #ACCodeStyler) new.! !

MethodCompilerFrontend subclass: #ACMethodCompilerFrontend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AncientCompiler-Frontend'!

!ACMethodCompilerFrontend class methodsFor: 'backward compatibility' stamp: 'EstebanAllende 11/27/2011 13:42'!
compatibilityOldCompilerClass
	^Compiler! !

!ACMethodCompilerFrontend class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/14/2011 11:54'!
defaultCompilerContext
	
	^nil! !

!ACMethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 11/27/2011 13:48'!
compileWithRequest: aCompileRequest usingCompilerContext: aCompilerContext

	"Compile code without logging the source in the changes file"

	| methodNode |
	methodNode  := Compiler new
				compile: aCompileRequest source
				in: aCompileRequest target
				classified: aCompileRequest category 
				notifying: aCompileRequest requestor
				ifFail: aCompileRequest failBlock.
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: aCompileRequest trailer.! !

!ACMethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 12/23/2011 16:40'!
evaluateWithRequest: aCompileRequest usingCompilerContext: aCompilerContext

	^Compiler new evaluate: aCompileRequest source in: aCompileRequest runtimeContext to: aCompileRequest target notifying: aCompileRequest requestor ifFail: aCompileRequest failBlock logged: false.! !

!ACMethodCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/13/2011 14:43'!
mapActiveContextToSource: aContext

	^(Debugger context: aContext) pcRange.! !

!ACMethodCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/13/2011 14:44'!
mapPasiveContextToSource: aContext
	self flag: 'map as active instead'.
	^(Debugger context: aContext) pcRange.! !

!ACMethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 11/27/2011 23:30'!
parseWithRequest: aCompileRequest usingCompilerContext: aCompilerContext

	"Compile code without logging the source in the changes file"

	| methodNode |
	methodNode  := RBParser parseMethod: aCompileRequest source onError: aCompileRequest failBlock.
	^ methodNode.! !

CompilerFrontend subclass: #AncientCompilerFrontend
	instanceVariableNames: 'methodCompiler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AncientCompiler-Frontend'!

!AncientCompilerFrontend class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 16:57'!
initialize
	CompilerFrontend registerCompiler: #AncientCompiler as: self new.
	CompilerFrontend defaultCompilerFrontend: #AncientCompiler.
	CompilerFrontend defaultEvaluatorFrontend: #AncientCompiler.! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 13:59'!
bcCompilerClass
	^Compiler! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 14:01'!
bcDecompilerClass
	^Compiler decompilerClass! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 14:01'!
bcEvaluatorClass
	^Compiler! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/14/2013 19:19'!
bcMethodMapper
	^DebuggerMethodMap! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 14:01'!
bcParserClass
	^Compiler parserClass! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 12:26'!
defaultCompilerContext
	^ACCompilerContext uniqueInstance! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 11:05'!
initialize
	methodCompiler := ACMethodCompilerFrontend new.! !

!AncientCompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 12:54'!
methodCompiler
	^methodCompiler! !
ACCompilerContext initialize!
AncientCompilerFrontend initialize!
